
#include <dlfcn.h>
#include <iostream>

struct A;
extern "C" {
	A *f();
}  // extern "C"

int main() {
	for( int i=0; i < 2; ++i ) {
		std::cerr << "main: before dlopen\n";
		void *h = dlopen( "libshareda.so", RTLD_LAZY );
		if ( h == 0 ) {
			std::cerr << "main: error in dlopen: "  << dlerror() << '\n';
			return 1;
		}
		std::cerr << "main: dlopen ok\n";
		std::cerr << "main: before dlsym\n";
		void *s = dlsym( h, "f" );
		if ( s == 0 ) {
			std::cerr << "main: error en dlsym: " << dlerror() << '\n';
			return 1;
		}
		std::cerr << "main: dlsym ok\n";
		std::cerr << "main: calling to f()\n";
		A *(*f)() = ( A*(*)() ) s;
		f();
		std::cerr << "main: f() ok\n";
		std::cerr << "main: before dlclose\n";
		if ( dlclose( h ) != 0 ) {
			std::cerr << "main: error in dlclose: "  << dlerror() << '\n';
			return 1;
		}
		std::cerr << "main: dlclose ok\n";
	}
	std::cerr << "main: leaving\n";
	return 0;
}
